/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/AliasList.java,v $
*
* $Author: furykid $
* $Date: 2003/04/01 19:08:12 $
*
* modification history:
*
* $Log: AliasList.java,v $
* Revision 1.4  2003/04/01 19:08:12  furykid
* cleanup
*
* Revision 1.3  2002/01/20 16:00:08  furykid
* test cvs keyword
*
* Revision 1.2  2002/01/20 15:57:10  furykid
* test cvs keyword
*

*********************************************************************************************/

package at.jps.mailserver;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;

/**
 * Alias List The ConfigurationManager reads the mail.cfg and fills the list with alias entries.
 * An entry should look like: Alias0=Mutter;gmutter
 * @author  Computer Mutter computer@mutter.com; Johannes Plachy
 * @version 0.99, 11/22/99
 */
final public class AliasList
{

   /**
    * Hashtable holds list of alias (keys) mapped to values ( usernames)
    */
   private Hashtable list;

   /**
    * constructs new empty list
    */
   public AliasList()
   {
      list = new Hashtable();
   }


   /**
    * The function adds an entry in the Hashtable
    * @param String username for which alias' have to be stored
    * @param aliaslist java.lang.String The key and value should be in the following format: alias1;alias2;alias3...
    */
   final public void add( String username, String aliaslist )
   {
      try
      {
         StringTokenizer   stringtokenizer = new StringTokenizer( aliaslist, ";" );
         String            key = null;

         do
         {
            key = stringtokenizer.nextToken();

            if ( key != null )
            {
               list.put( key.toLowerCase(), username.toLowerCase() );

               if ( Debug.enabled )
               {
                  System.out.println( "alias = " + key.toLowerCase() + " -> user: " + username.toLowerCase() );
               }
            }
         }
         while ( key != null );
      }
      catch ( Exception exception )
      {

         // System.out.println(exception + " Alias=" + aliaslist);

      }
   }


   /**
    * The function gets the alias from the Hashtable Is no alias in the list, the function returns null
    * @param name java.lang.String The key
    */
   final public String getAlias( String s )
   {
      return ( String )list.get( s.toLowerCase() );
   }


   /**
    * this function returns a list of keys ( which are alias entries) to find the corresponding username
    * Is no alias in the list, the function returns null
    * @return Enumeration of Keys
    */
   final Enumeration getKeys()
   {
      return list.keys();
   }


   /**
    * Method declaration
    * @param args
    */
   public static void main( String args[] )
   {
      AliasList   aliaslist = new AliasList();

      aliaslist.add( "Johannes", "Webmaster;Boss;Chef;Master;Guru" );
      aliaslist.add( "Gisela", "Test;Gisi;" );
      System.out.println( aliaslist.getAlias( "Webmaster" ) );
      System.out.println( aliaslist.getAlias( "Test" ) );
   }


}







/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

