/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/BASE64DecoderStream.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: BASE64DecoderStream.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.io.*;

/**
 * Class declaration
 *
 *
 * @author Johannes Plachy
 * @version %I%, %G%
 */
public class BASE64DecoderStream extends FilterInputStream
{

   /**
    * Constructor declaration
    *
    *
    * @param inputstream
    *
    *
    */
   public BASE64DecoderStream( InputStream inputstream )
   {
      super( inputstream );

      decode_buffer = new byte[ 4 ];
      buffer = new byte[ 3 ];
   }


   /**
    * Method declaration
    *
    *
    * @return
    *
    * @throws IOException
    *
    */
   public int read() throws IOException
   {
      if ( index >= bufsize )
      {
         decode();

         if ( bufsize == 0 )
         {
            return -1;
         }

         index = 0;
      }

      return buffer[ index++ ] & 0xff;
   }


   /**
    * Method declaration
    *
    *
    * @param abyte0
    *
    * @param i
    *
    * @param j
    *
    *
    * @return
    *
    * @throws IOException
    *
    */
   public int read( byte abyte0[], int i, int j ) throws IOException
   {
      int   k;

      try
      {
         for ( k = 0; k < j; k++ )
         {
            int   l;

            if ( ( l = read() ) == -1 )
            {
               if ( k == 0 )
               {
                  k = -1;
               }

               break;
            }

            abyte0[ i + k ] = ( byte )l;
         }
      }
      catch ( IOException _ex )
      {
         k = -1;
      }

      return k;
   }


   /**
    * Method declaration
    *
    *
    * @return
    *
    */
   public boolean markSupported()
   {
      return false;
   }


   /**
    * Method declaration
    *
    *
    * @return
    *
    * @throws IOException
    *
    */
   public int available() throws IOException
   {
      return ( in.available() * 3 ) / 4 + ( bufsize - index );
   }


   /**
    * Method declaration
    *
    *
    * @throws IOException
    *
    */
   private void decode() throws IOException
   {
      bufsize = 0;

      int   i;

      do
      {
         i = in.read();

         if ( i == -1 )
         {
            return;
         }
      }
      while ( i == 10 || i == 13 );

      decode_buffer[ 0 ] = ( byte )i;

      int   j = 3;
      int   l;

      for ( int k = 1; ( l = in.read( decode_buffer, k, j ) ) != j; k += l )
      {
         if ( l == -1 )
         {
            throw new IOException( "Error in encoded stream" );
         }

         j -= l;
      }

      byte  byte0 = pem_convert_array[ decode_buffer[ 0 ] & 0xff ];
      byte  byte2 = pem_convert_array[ decode_buffer[ 1 ] & 0xff ];

      buffer[ bufsize++ ] = ( byte )( byte0 << 2 & 0xfc | byte2 >>> 4 & 0x3 );

      if ( decode_buffer[ 2 ] == 61 )
      {
         return;
      }

      byte0 = byte2;
      byte2 = pem_convert_array[ decode_buffer[ 2 ] & 0xff ];
      buffer[ bufsize++ ] = ( byte )( byte0 << 4 & 0xf0 | byte2 >>> 2 & 0xf );

      if ( decode_buffer[ 3 ] == 61 )
      {
         return;
      }
      else
      {
         byte  byte1 = byte2;

         byte2 = pem_convert_array[ decode_buffer[ 3 ] & 0xff ];
         buffer[ bufsize++ ] = ( byte )( byte1 << 6 & 0xc0 | byte2 & 0x3f );

         return;
      }
   }


   private byte               buffer[];
   private int                bufsize;
   private int                index;
   private static final char  pem_array[] =
   {
      'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'
   };
   private static final byte  pem_convert_array[];
   private byte               decode_buffer[];

   static
   {
      pem_convert_array = new byte[ 256 ];

      for ( int i = 0; i < 255; i++ )
      {
         pem_convert_array[ i ] = -1;
      }

      for ( int j = 0; j < pem_array.length; j++ )
      {
         pem_convert_array[ pem_array[ j ] ] = ( byte )j;
      }
   }
}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

