/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/BASE64EncoderStream.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: BASE64EncoderStream.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.io.*;

/**
 * Class declaration
 *
 *
 * @author Johannes Plachy
 * @version %I%, %G%
 */
public class BASE64EncoderStream extends FilterOutputStream
{

   /**
    * Constructor declaration
    *
    *
    * @param outputstream
    *
    * @param i
    *
    *
    */
   public BASE64EncoderStream( OutputStream outputstream, int i )
   {
      super( outputstream );

      buffer = new byte[ 3 ];
      bytesPerLine = i;
   }


   /**
    * Constructor declaration
    *
    *
    * @param outputstream
    *
    *
    */
   public BASE64EncoderStream( OutputStream outputstream )
   {
      this( outputstream, 76 );
   }


   /**
    * Method declaration
    *
    *
    * @param abyte0
    *
    * @param i
    *
    * @param j
    *
    *
    * @throws IOException
    *
    */
   public void write( byte abyte0[], int i, int j ) throws IOException
   {
      for ( int k = 0; k < j; k++ )
      {
         write( abyte0[ i + k ] );
      }
   }


   /**
    * Method declaration
    *
    *
    * @param abyte0
    *
    *
    * @throws IOException
    *
    */
   public void write( byte abyte0[] ) throws IOException
   {
      write( abyte0, 0, abyte0.length );
   }


   /**
    * Method declaration
    *
    *
    * @param i
    *
    *
    * @throws IOException
    *
    */
   public void write( int i ) throws IOException
   {
      buffer[ bufsize++ ] = ( byte )i;

      if ( bufsize == 3 )
      {
         encode();

         bufsize = 0;
      }
   }


   /**
    * Method declaration
    *
    *
    * @throws IOException
    *
    */
   public void flush() throws IOException
   {
      if ( bufsize > 0 )
      {
         encode();

         bufsize = 0;
      }

      out.flush();
   }


   /**
    * Method declaration
    *
    *
    * @throws IOException
    *
    */
   public void close() throws IOException
   {
      flush();
      out.close();
   }


   /**
    * Method declaration
    *
    *
    * @throws IOException
    *
    */
   private void encode() throws IOException
   {
      if ( count + 4 > bytesPerLine )
      {
         out.write( 13 );
         out.write( 10 );

         count = 0;
      }

      if ( bufsize == 1 )
      {
         byte     byte0 = buffer[ 0 ];
         int      i = 0;
         //boolean  flag = false;

         out.write( pem_array[ byte0 >>> 2 & 0x3f ] );
         out.write( pem_array[ ( byte0 << 4 & 0x30 ) + ( i >>> 4 & 0xf ) ] );
         out.write( 61 );
         out.write( 61 );
      }
      else if ( bufsize == 2 )
      {
         byte  byte1 = buffer[ 0 ];
         byte  byte3 = buffer[ 1 ];
         int   j = 0;

         out.write( pem_array[ byte1 >>> 2 & 0x3f ] );
         out.write( pem_array[ ( byte1 << 4 & 0x30 ) + ( byte3 >>> 4 & 0xf ) ] );
         out.write( pem_array[ ( byte3 << 2 & 0x3c ) + ( j >>> 6 & 0x3 ) ] );
         out.write( 61 );
      }
      else
      {
         byte  byte2 = buffer[ 0 ];
         byte  byte4 = buffer[ 1 ];
         byte  byte5 = buffer[ 2 ];

         out.write( pem_array[ byte2 >>> 2 & 0x3f ] );
         out.write( pem_array[ ( byte2 << 4 & 0x30 ) + ( byte4 >>> 4 & 0xf ) ] );
         out.write( pem_array[ ( byte4 << 2 & 0x3c ) + ( byte5 >>> 6 & 0x3 ) ] );
         out.write( pem_array[ byte5 & 0x3f ] );
      }

      count += 4;
   }


   private byte               buffer[];
   private int                bufsize;
   private int                count;
   private int                bytesPerLine;
   private static final char  pem_array[] =
   {
      'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'
   };
}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

