/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/BugReportMsg.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: BugReportMsg.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.text.SimpleDateFormat;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Class declaration
 *
 *
 * @author Johannes Plachy
 * @version %I%, %G%
 */
class BugReportMsg
{

   /**
    * Constructor declaration
    *
    *
    */
   private BugReportMsg() {}


   /**
    * Method declaration
    *
    *
    * @param sender
    *
    * @param receiver
    *
    * @param subject
    *
    * @param messageReader
    *
    * @param configuration
    *
    *
    */
   public static void createUndeliverableReplyMessgae( String sender, String receiver, String subject, BufferedReader messageReader, ConfigurationManager configuration )
   {
      SimpleDateFormat  dateFormat = new SimpleDateFormat( "EEE, d MMM yyyy HH:mm:ss (z)", Locale.US );
      File              tempFile = null;
      PrintWriter       fileWriter = null;
      StringTokenizer   stringtokenizer = new StringTokenizer( sender, "<@>" );
      String            senderName = configuration.getReceiverName( stringtokenizer.nextToken() );

      try
      {
         tempFile = File.createTempFile( "jms", null );
         fileWriter = new PrintWriter( new BufferedWriter( new FileWriter( tempFile ) ) );

//         String   localDomains = configuration.getLocalDomain();
         
//         String   localDomain = null;
//         int      ix = localDomains.indexOf( ';' );
//
//         if ( ix >= 0 )
//         {
//
//            // in case we have more than one local domain specified
//            // just take the first one
//
//            localDomain = localDomains.substring( 0, ix );
//         }
//         else
//         {
//            localDomain = localDomains;
//         }

         fileWriter.write( "From: Java Mail Server <JMailSrv@" + configuration.getLocalDomain() + ">\n" );
         fileWriter.write( "Reply-To: " + senderName + " " + sender + "\n" );
         fileWriter.write( "To: " + senderName + " " + sender + "\n" );
         fileWriter.write( "Subject: " + subject + "\n" );
         fileWriter.write( "Date: " + dateFormat.format( new Date() ) + "\n" );
         fileWriter.write( "MIME-Version: 1.0\n" );
         fileWriter.write( "Content-Type: multipart/mixed;\n" );
         fileWriter.write( "        boundary=\"----=_NextPart_000_0001.JMS\"\n" );
         fileWriter.write( "Importance: High\n \n" );
         fileWriter.write( "------=_NextPart_000_0001.JMS\n" );
         fileWriter.write( "Content-Type: text/plain;\n" );
         fileWriter.write( "        charset=\"iso-8859-1\"\n" );
         fileWriter.write( "Content-Transfer-Encoding: 7bit\n\n" );
         fileWriter.write( "Dear " + senderName + ",\n \n" );
         fileWriter.write( "the attached message could not be livered to: " + receiver + "\n \n" );
         fileWriter.write( "please check the address of the receiver and try again !" );
         fileWriter.write( "\n \n \nIf you think this is a bug please send a detailed description to\n" );
         fileWriter.write( "mailto:JMailSrv@jps.at \n \n" );
         fileWriter.write( "Thank you very much.\n \n" );
         fileWriter.write( "Java Mail Server\n" );
         fileWriter.write( "by Johannes Plachy\n" );
         fileWriter.write( "One Step Ahead Software\n\n" );
         fileWriter.write( "------=_NextPart_000_0001.JMS\n" );
         fileWriter.write( "Content-Type: message/rfc822\n" );
         fileWriter.write( "Content-Transfer-Encoding: 7bit\n" );
         fileWriter.write( "Content-Disposition: attachment\n\n" );
         messageReader.reset();

         String   line = null;

         do
         {
            line = messageReader.readLine();

            if ( line != null )
            {
               fileWriter.write( line + "\n" );
            }
         }
         while ( line != null );

         fileWriter.write( "\n------=_NextPart_000_0001.JMS--\n" );
         fileWriter.flush();
         configuration.getMessageHandler().saveMessage( tempFile.getAbsolutePath(), senderName, null, null );
      }
      catch ( Exception x )
      {

         // error creating Message

      }
      finally
      {
         if ( fileWriter != null )
         {
            try
            {
               fileWriter.close();
            }
            catch ( Exception x ) {}
         }

         if ( tempFile != null )
         {
            tempFile.delete();
         }
      }
   }


   /**
    * Method declaration
    *
    *
    * @param t
    *
    * @param configuration
    *
    *
    * @return
    *
    */
   public static String createExceptionAlertMessage( Throwable t, ConfigurationManager configuration )
   {
      StringBuffer      msg = new StringBuffer( "From: \"Java Mail Server\" <JMailSrv@" );
      SimpleDateFormat  dateFormat = new SimpleDateFormat( "EEE, d MMM yyyy HH:mm:ss 'XXXXX' (z)", Locale.US );
      Throwable         info = t.fillInStackTrace();

      msg.append( configuration.getLocalDomain() ).append( ">\n" );
      msg.append( "Reply-To: <JMailSrv@jps.at>\n" );
      msg.append( "To: Mail Administrator <" ).append( configuration.getAdmin() + "@" + configuration.getLocalDomain() + ">\n" );
      msg.append( "Subject: Error message from Java-Mail Server\n" );
      msg.append( "Date: " + dateFormat.format( new Date() ) + "\n" );
      msg.append( "MIME-Version: 1.0\n" );
      msg.append( "Content-Type: multipart/alternative;\n" );
      msg.append( "boundary=\"----=_NextPart_000_0004_01BFB84E.28FE0840\"\n" );
      msg.append( "Importance: High\n" );
      msg.append( "This is a multi-part message in MIME format.\n" );
      msg.append( "------=_NextPart_000_0004_01BFB84E.28FE0840\n" );
      msg.append( "Content-Type: text/plain;\n" );
      msg.append( "charset=\"iso-8859-1\"\n" );
      msg.append( "Content-Transfer-Encoding: 7bit\n" );
      msg.append( "Dear Mailserver administrator,\n \n" );
      msg.append( "an exception happend during mailprocessing:\n \n" );
      msg.append( info.toString() );
      msg.append( "\n \n \nIf you think this is a bug please send a detailed description to\n" );
      msg.append( "mailto:JMailSrv@jps.at or simply reply to this mail\n \n" );
      msg.append( "Thank you very much and sorry for the error.\n \n" );
      msg.append( "for updates please visit\n" );
      msg.append( "http://www.jps.at/java/tools/mailserver.html\n\n" );
      msg.append( "------=_NextPart_000_0004_01BFB84E.28FE0840\n" );

      // msg.append("Content-Type: text/html;\n");
      // msg.append("charset=\"iso-8859-1\"\n");
      // msg.append("Content-Transfer-Encoding: quoted-printable\n");
      // msg.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n");
      // msg.append("<HTML><HEAD>\n");
      // msg.append("<META content=3D\"text/html; charset=3Diso-8859-1\" =\n");
      // msg.append("http-equiv=3DContent-Type>\n");
      // msg.append("<META content=3D\"MSHTML 5.00.2920.0\" name=3DGENERATOR></HEAD>\n");
      // msg.append("<BODY bgColor=3D#000080>\n");
      // msg.append("<DIV><FONT color=3D#ffff00 face=3D\"Arial Black\" size=3D2><SPAN=20\n");
      // msg.append("class=3D201075315-07052000>Dear Mailserver =\n");
      // msg.append("administrator,</SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN =\n");
      // msg.append("class=3D201075315-07052000></SPAN></FONT>&nbsp;</DIV>\n");
      // msg.append("<DIV><FONT color=3D#ffff00 face=3D\"Arial Black\" size=3D2><SPAN=20\n");
      // msg.append("class=3D201075315-07052000>an exception happend during=20\n");
      // msg.append("mailprocessing:</SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN =\n");
      // msg.append("class=3D201075315-07052000></SPAN></FONT>&nbsp;</DIV>\n");
      // msg.append("<DIV><FONT color=3D#ffff00 face=3D\"Arial Black\" size=3D2><SPAN=20\n");
      // msg.append("class=3D201075315-07052000>" + info.toString() + "</SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN =\n");
      // msg.append("class=3D201075315-07052000></SPAN></FONT>&nbsp;</DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN =\n");
      // msg.append("class=3D201075315-07052000></SPAN></FONT>&nbsp;</DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN class=3D201075315-07052000><FONT =\n");
      // msg.append("color=3D#ffff00=20\n");
      // msg.append("face=3D\"Arial Black\">If you think this is a bug please send a detailed =\n");
      // msg.append("description=20\n");
      // msg.append("to </FONT><A href=3D\"mailto:JMailSrv@jps.at\"><FONT color=3D#00ffff=20\n");
      // msg.append("face=3D\"Arial Black\">mailto:JMailSrv@jps.at</FONT></A><FONT =\n");
      // msg.append("color=3D#ffff00=20\n");
      // msg.append("face=3D\"Arial Black\"> </FONT></SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT color=3D#ffff00 face=3D\"Arial Black\" size=3D2><SPAN=20\n");
      // msg.append("class=3D201075315-07052000>Thank you very much and sorry for the=20\n");
      // msg.append("error.</SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT size=3D2></FONT>&nbsp;</DIV>\n");
      // msg.append("<DIV><FONT color=3D#ffff00 face=3D\"Arial Black\" size=3D2><SPAN=20\n");
      // msg.append("class=3D201075315-07052000>for updates please visit</SPAN></FONT></DIV>\n");
      // msg.append("<DIV><FONT size=3D2><SPAN class=3D201075315-07052000></SPAN><A=20\n");
      // msg.append("href=3D\"http://www.jps.at/java/tools/mailserver.html\"><FONT =\n");
      // msg.append("color=3D#00ffff=20\n");
      // msg.append("face=3D\"Arial =\n");
      // msg.append("Black\">http://www.jps.at/java/tools/mailserver.html</FONT></A></FONT></DIV></BODY></HTML>\n");
      // msg.append("------=_NextPart_000_0004_01BFB84E.28FE0840--\n");

      msg.append( "" );

      return msg.toString();
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

