/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/MailMessage.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: MailMessage.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

/**
 * stores one message ivMessage is not necessarily valid after constructing
 * this class is also used as wrapper to hold size and ID information ( only shallow initialized !)
 * please use MessageHandler getMessage() to physically fetch message use isFetched() to verify !
 * @author  Johannes Plachy
 * @version 0.99, 11/22/99
 */
import java.io.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
class MailMessage
{

   /**
    * unique ID
    */
   private Object          ivID;

   /**
    * The EMail
    */
   private String          ivMessage;

   /**
    * size of the email
    */
   private long            ivSize;

   /**
    * user that receives this message
    */
   private String          ivUser;

   /**
    * ivIsFetched is true if MailMessage is not shallow anymore
    */
   private boolean         ivIsFetched;
   private BufferedReader  ivMessageReader;

   /**
    * construct empty message
    */
   MailMessage()
   {
      ivIsFetched = false;
   }


   /**
    * construct empty message with id and messagetext
    * @param unique ID
    * @param message body
    */
   MailMessage( String ID, String Message )
   {
      setID( ID );
      setMessage( Message );
   }


   /**
    * user for is the receiver of this message
    * @return username
    */
   String getUser()
   {
      return ivUser;
   }


   /**
    * user for is the receiver of this message
    * @param username
    */
   void setUser( String User )
   {
      ivUser = User;
   }


   /**
    * unique ID of this message
    * @return ID
    */
   Object getID()
   {
      return ivID;
   }


   /**
    * unique ID of this message
    * @param ID
    */
   void setID( Object ID )
   {
      ivID = ID;
   }


   /**
    * returns EMail
    * @return normal Email
    */
   public String getMessage()
   {
      if ( !isFetched() )
      {
         readMessage();
      }

      return ivMessage;
   }


   /**
    * set EMail
    * @param new EMail
    */
   void setMessage( String Message )
   {
      ivMessage = Message;
      ivIsFetched = true;
   }


   /**
    * returns information if it is completely fetched
    * @return true if completely fetched
    */
   boolean isFetched()
   {
      return ivIsFetched;
   }


   /**
    * size of the EMail
    * @param new size
    */
   void setSize( long Size )
   {
      ivSize = Size;
   }


   /**
    * size of the EMail
    * @return size
    */
   long getSize()
   {
      return ivSize;
   }


   /**
    * Method declaration
    * @return
    */
   BufferedReader getReader()
   {
      return ivMessageReader;
   }


   /**
    * Method declaration
    * @param reader
    */
   void setReader( BufferedReader reader )
   {
      ivMessageReader = reader;
   }


   /**
    * read entire message to internal buffer
    */
   public void readMessage()
   {
      try
      {
         FileInputStream   fileinputstream = new FileInputStream( ( String )getID() );
         BufferedReader    bufferedreader = new BufferedReader( new InputStreamReader( fileinputstream ) );
         StringBuffer      newMsg = new StringBuffer();
         String            line = null;

         while ( ( line = bufferedreader.readLine() ) != null )
         {
            newMsg.append( line ).append( "\n" );
         }

         fileinputstream.close();
         bufferedreader.close();
         setMessage( newMsg.toString() );
      }
      catch ( Exception x ) {}
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

