/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/MailServerAdminImpl.java,v $
*
* $Author: furykid $
* $Date: 2004/01/22 20:12:35 $
*
* modification history:
*
* $Log: MailServerAdminImpl.java,v $
* Revision 1.4  2004/01/22 20:12:35  furykid
* cleanup of finally blocks which caused compiler warnings
*
* Revision 1.3  2003/04/01 19:08:12  furykid
* cleanup
*
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.Date;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class MailServerAdminImpl extends UnicastRemoteObject implements MailServerAdmin
{
    private static MailServerAdminImpl  cvInstance = null;
    private static String               cvHomeDir = null;

    /**
     * Constructor declaration
     */
    private MailServerAdminImpl() throws java.rmi.RemoteException
    {
        super();
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public Date getStartTime() throws RemoteException
    {
        return MailStatistic.getInstance().getStartTime();
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public long getNrOfOutgoingMail() throws RemoteException
    {
        return MailStatistic.getInstance().getNrOfOutgoingMail();
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public long getNrOfIncomingMail() throws RemoteException
    {
        return MailStatistic.getInstance().getNrOfIncomingMail();
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public long getSizeOfOutgoingMail() throws RemoteException
    {
        return MailStatistic.getInstance().getSizeOfOutgoingMail();
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public long getSizeOfIncomingMail() throws RemoteException
    {
        return MailStatistic.getInstance().getSizeOfIncomingMail();
    }


    /**
     * Method declaration
     * @param User
     * @return
     * @throws RemoteException
     */
    public boolean isAutoResponseEnabled( String User ) throws RemoteException
    {
        return true;
    }


    /**
     * Method declaration
     * @return
     */
    public static MailServerAdminImpl getInstance()
    {
        try
        {
            if ( cvInstance == null )
            {
                cvInstance = new MailServerAdminImpl();
            }
        }
        catch ( Exception exception )
        {
            ErrorReporter.getInstance().writeStatusMsg( exception.toString(), "Error" );
        }
        return cvInstance;
    }


    /**
     * Method declaration
     * @return
     * @throws RemoteException
     */
    public Settings getSettings() throws RemoteException
    {
        return MailServer.getInstance().getConfiguration().getSettings();
    }


    /**
     * Method declaration
     * @param settings
     * @throws RemoteException
     */
    public void setSettings( Settings settings ) throws RemoteException
    {
        MailServer.getInstance().getConfiguration().setSettings( settings, true );

        ErrorReporter.getInstance().writeStatusMsg( "Configuration Data uptdated correctly", "Information" );
    }


    /**
     * Method declaration
     * @param HomeDir
     */
    private void initialize( String HomeDir )
    {
        cvHomeDir = HomeDir;
    }


    /**
     * Method declaration
     * @param hostname
     * @return
     * @throws NotBoundException
     * @throws RemoteException
     * @throws java.net.MalformedURLException
     */
    public static MailServerAdmin getRemoteInstance( String hostname ) throws NotBoundException, java.net.MalformedURLException, RemoteException
    {
        return( MailServerAdmin )Naming.lookup( getServiceName( hostname) );
    }

    private static String getServiceName(String hostname)
    {
       return "//" + hostname + "/MailServerAdmin";
    }

    /**
     * Method declaration
     * @param hostname
     * @param HomeDir
     * @throws RemoteException
     * @throws java.net.MalformedURLException
     */
    public static void registerServerAdmin( String hostname, String HomeDir ) throws RemoteException, java.net.MalformedURLException
    {
        try
        {
            Naming.rebind( getServiceName( hostname), getInstance() );
        }
        catch ( RemoteException x)
        {
            ErrorReporter.getInstance().writeStatusMsg( "no RMI registry available at the specified port\nA new rmi registry will be created and used instead !", "Warning" );

            Registry reg = LocateRegistry.createRegistry( Registry.REGISTRY_PORT );

            reg.rebind( getServiceName( hostname), getInstance() );
        }

        getInstance().initialize( HomeDir );

        ErrorReporter.getInstance().writeStatusMsg( "RMI registration successfull! Name used ="+ getServiceName( hostname));

    }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

