/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/MessageHandler.java,v $
*
* $Author: furykid $
* $Date: 2003/04/01 19:08:11 $
*
* modification history:
*
* $Log: MessageHandler.java,v $
* Revision 1.4  2003/04/01 19:08:11  furykid
* cleanup
*
* Revision 1.3  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.util.Vector;

/**
 * MessageHandler spezifies the interface all Handlers have to follow there are methods to save and retrieve Message info
 * @author  Johannes Plachy
 * @version 0.99, 11/22/99
 */
interface MessageHandler
{

   /**
    * initialization is Handlerspezific but it is called only once at creationtime
    */
   void initialize();

   /**
    * save message persistently
    * @param tempFilename
    * @param user   for which to store the message
    * @param ExternalUsers comma seperated list of external users - might be null
    */
   void saveMessage( String tempFilename, String user, String sender, Vector ExternalUsers );

   /**
    * Method declaration
    * @param user
    * @param message
    */
   public void saveMessage( String user, String message );

   /**
    * retrieve Messages shallow
    * @param username
    * @return Array of Messages which are only shallow initialized
    * @see MailMessage
    */
   MailMessage[] getMessages( String user );    // this messages are just wrappers !

   /**
    * retrieve a MailMessage complete
    * @param message which has to be initialized shallow
    * @return true if the message could be found and retrieved
    * @see MailMessage
    */
   boolean getNextMessage( MailMessage message );

   /**
    * retrieve a MailMessage based on a passed Id
    * @param id that identifies a message uniquely
    * @return MailMessage that has been retrieved
    * @see MailMessage
    */
   MailMessage getOutgoingMessage( String id );

   /**
    * retrieve the number of messages available for processing
    * @param user name
    * @return number of messages
    */
   long getNrOfMessages( String user );

   /**
    * delete spezific MailMessage from persistant storage
    * @param MailMessage
    */
   void deleteMessage( MailMessage message );

   /**
    * Method declaration
    *
    *
    * @param messageId
    *
    *
    */
   void deleteMessage( String messageId );

   /**
    * verifies the physical existance of the message
    * @param messageId
    */
   boolean existsMessage( String messageId );

   /**
    * check connection to persistant storage facility
    * @returns true if store is accessable
    */
   boolean isConnected();
}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

