/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/MessageHandlerImpl.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: MessageHandlerImpl.java,v $
* Revision 1.3  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.io.*;
import java.util.Vector;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
abstract class MessageHandlerImpl
{

   /**
    * Method declaration
    */
   abstract void initialize();

   /**
    * Method declaration
    * @param file containing the message
    * @param user
    * @param ExternalUsers
    */
   void saveMessage( String temFilename, String user, Vector ExternalUsers )
   {
      MailStatistic  statistics = MailStatistic.getInstance();
      File           file = new File( temFilename );

      if ( Sender.getOutgoingMailQueueName().equalsIgnoreCase( user ) )
      {
         statistics.setNrOfOutgoingMail( statistics.getNrOfOutgoingMail() + 1 );
         statistics.setSizeOfOutgoingMail( statistics.getSizeOfOutgoingMail() + file.length() );
      }
      else
      {
         statistics.setNrOfIncomingMail( statistics.getNrOfIncomingMail() + 1 );
         statistics.setSizeOfIncomingMail( statistics.getSizeOfIncomingMail() + file.length() );
      }
   }


   /**
    * Method declaration
    * @param user
    * @param message
    */
   public void saveMessage( String user, String message )
   {
      MailStatistic  statistics = MailStatistic.getInstance();

      if ( Sender.getOutgoingMailQueueName().equalsIgnoreCase( user ) )
      {
         statistics.setNrOfOutgoingMail( statistics.getNrOfOutgoingMail() + 1 );
         statistics.setSizeOfOutgoingMail( statistics.getSizeOfOutgoingMail() + message.length() );
      }
      else
      {
         statistics.setNrOfIncomingMail( statistics.getNrOfIncomingMail() + 1 );
         statistics.setSizeOfIncomingMail( statistics.getSizeOfIncomingMail() + message.length() );
      }
   }


   /**
    * Method declaration
    * @param user
    * @return
    */
   abstract MailMessage[] getMessages( String user );    // this messages are just wrappers !

   /**
    * Method declaration
    * @param message
    * @return
    */
   abstract boolean getNextMessage( MailMessage message );

   /**
    * Method declaration
    * @param user
    * @return
    */
   abstract long getNrOfMessages( String user );

   /**
    * Method declaration
    * @param Message
    */
   abstract void deleteMessage( MailMessage Message );

   /**
    * Method declaration
    * @return
    */
   abstract boolean isConnected();

   /**
    * write errordescription to status log file
    * @param s      errordescription
    */
   protected static void writeToLog( String s )
   {
      ErrorReporter.getInstance().writeStatusMsg( s );
   }


   /**
    * write information about exceptions to logging facility
    * @param exception that has to be logged
    */
   final protected static void handleException( Throwable throwable )
   {
      writeToLog( " Error occured in MessageHandler = " + throwable.toString() );

      if ( Debug.enabled )
      {
         throwable.printStackTrace();
      }
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

