/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/MessageInfo.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: MessageInfo.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.util.Date;
import java.util.Vector;

/**
 * Class declaration
 * @author Johannes plachy
 * @version %I%, %G%
 */
class MessageInfo implements java.io.Serializable
{
   private Date      ivCreationDate;
   private Date      ivLastTryDate;
   private int       ivTryCount;
   private Vector    ivReceivers;
   private String    ivMessageId;
   final static int  MAX_RETRY = 1;

   /**
    * Constructor declaration
    * @param MessageId
    * @param receivers
    */
   MessageInfo( String MessageId, Vector receivers )
   {
      ivCreationDate = new Date();
      ivTryCount = 0;
      ivReceivers = receivers;
      ivMessageId = MessageId;
   }


   /**
    * Method declaration
    *
    *
    * @return
    *
    */
   int getMaxRetryCount()
   {
      return MAX_RETRY;
   }


   /**
    * Method declaration
    * @return
    */
   String getMessageId()
   {
      return ivMessageId;
   }


   /**
    * Method declaration
    * @param MessageId
    */
   void setMessageId( String MessageId )
   {
      ivMessageId = MessageId;
   }


   /**
    * Method declaration
    * @param date
    */
   void setCreationDate( Date date )
   {
      ivCreationDate = date;
   }


   /**
    * Method declaration
    *
    *
    * @return
    *
    */
   Date getLastTryDate()
   {
      return ivLastTryDate;
   }


   /**
    * Method declaration
    * @return
    */
   Date getCreationDate()
   {
      return ivCreationDate;
   }


   /**
    * Method declaration
    * @param count
    */
   void setTryCount( int count )
   {
      ivTryCount = count;
   }


   /**
    * Method declaration
    * @return
    */
   int getTryCount()
   {
      return ivTryCount;
   }


   /**
    * Method declaration
    * @return
    */
   boolean tryAgain()
   {
      if ( getTryCount() == 0 )
      {
         return true;
      }
      else
      {
         Date  hourAgo = new java.util.Date( System.currentTimeMillis() - 60 * 60 * 1000 );

         if ( getLastTryDate().before( hourAgo ) )
         {
            ivLastTryDate = new Date();   // datum aktualisieren

            return true;
         }
         else
         {
            return false;
         }
      }
   }


   /**
    * Method declaration
    * @param receivers
    */
   void setReceivers( Vector receivers )
   {
      ivReceivers = receivers;
   }


   /**
    * Method declaration
    * @return
    */
   Vector getReceivers()
   {
      return ivReceivers;
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

