/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/ProhibitRelayFilter.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: ProhibitRelayFilter.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.util.StringTokenizer;
import java.util.Iterator;
import java.util.Vector;

/**
 * allow only messages to be received that either come from the local domain or are to be delivered locally.
 * no message relaying is supported
 */
public class ProhibitRelayFilter implements IncomingMailFilter
{

   /**
    * Method declaration
    *
    *
    * @param destinationDomain
    *
    * @param localDomains
    *
    *
    * @return
    *
    */
   private boolean isDomainInLocalDomains( String destinationDomain, Vector localDomains )
   {
      boolean  result = false;
      Iterator iterator = localDomains.iterator();

      System.out.println( "-> "+localDomains);

      while ( ( iterator.hasNext() ) && ( result == false ) )
      {
         String localDomain = ( String )iterator.next();

         System.out.println( "-> "+localDomain);

         if ( destinationDomain.equalsIgnoreCase( localDomain ) == true )
         {
            result = true;
         }
      }

      return result;
   }


   /**
    * Method declaration
    *
    *
    * @param sender
    *
    * @param receiver
    *
    * @param subject
    *
    * @param localDomains
    *
    *
    * @return
    *
    */
   public boolean allowMessageToBeReceived( String sender, String receiver, String subject, Vector localDomains )
   {
      boolean  allow = false;

      try
      {

         System.out.println( sender + " - " + receiver);

         StringTokenizer   stringtokenizer = new StringTokenizer( sender, "<@>" );
         String            name = stringtokenizer.nextToken();
         String            senderDomain = stringtokenizer.nextToken();

         stringtokenizer = new StringTokenizer( receiver, "<@>" );
         name = stringtokenizer.nextToken();

         String   receiverDomain = stringtokenizer.nextToken();

         System.out.println( senderDomain + " - " + receiverDomain);

         // if (localDomain.equalsIgnoreCase(receiverDomain) || localDomain.equalsIgnoreCase(senderDomain))

         if ( isDomainInLocalDomains( receiverDomain, localDomains ) || isDomainInLocalDomains( senderDomain, localDomains ) )
         {
            allow = true;
         }

         if ( Debug.enabled == true )
         {
            ErrorReporter.getInstance().writeSmtpMsg("mail checked from '" + sender + " (" + senderDomain + ")' to '" + receiver + " (" + receiverDomain + ")'" );
            ErrorReporter.getInstance().writeSmtpMsg("mail processing "+(allow ? "allowed": "prohibited"));
         }
      }
      catch ( Exception x )
      {
          ErrorReporter.getInstance().writeSmtpMsg("Exception in <allowMessageToBeReceived>="+x.toString(), "Error");
      }

      return allow;
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

