/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/Settings.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: Settings.java,v $
* Revision 1.3  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.io.*;
import java.util.*;

/**
 * Settings class wraps mailserver settings and extends observable to be watched by clients
 * Other classes can use the getter functions to receive the values.
 * @author  Johannes Plachy
 * @version 0.99, 11/22/99
 */
public class Settings extends Observable implements Serializable
{

   /*
    * default constructor
    *
    */

   /**
    * Constructor declaration
    */
   public Settings() {}


   /*
    * serialize object to stream
    *
    * @param inputstream
    *
    * @throws ClassNotFoundException, IOException
    */

   /**
    * Method declaration
    * @param ois
    * @throws ClassNotFoundException
    * @throws IOException
    */
   void readObject( ObjectInputStream ois ) throws ClassNotFoundException, IOException
   {
      ois.defaultReadObject();
   }


   /*
    * read object from stream
    *
    * @param ouputstream
    *
    * @throws IOException
    */

   /**
    * Method declaration
    * @param oos
    * @throws IOException
    */
   void writeObject( ObjectOutputStream oos ) throws IOException
   {
      oos.defaultWriteObject();
   }


   /**
    * Method declaration
    * @param newHomeDirectory
    */
   public void setHomeDirectory( String newHomeDirectory )
   {
      homeDirectory = newHomeDirectory;
   }


   /**
    * Method declaration
    * @return
    */
   public String getHomeDirectory()
   {
      return homeDirectory;
   }


   /**
    * Method declaration
    * @param newLocalDomainName
    */
   public void setLocalDomainName( String newLocalDomainName )
   {
      localDomainName = newLocalDomainName;
   }


   /**
    * Method declaration
    * @return
    */
   public String getLocalDomainName()
   {
      return localDomainName;
   }


   /**
    * Method declaration
    * @param newSMTPServer
    */
   public void setSMTPServer( String newSMTPServer )
   {
      SMTPServer = newSMTPServer;
   }


   /**
    * Method declaration
    * @return
    */
   public String getSMTPServer()
   {
      return SMTPServer;
   }


   /**
    * Method declaration
    * @param newUnknownUser
    */
   public void setUnknownUsername( String newUnknownUser )
   {
      unknownUser = newUnknownUser;
   }


   /**
    * Method declaration
    * @return
    */
   public String getUnknownUsername()
   {
      return unknownUser;
   }


   /**
    * Method declaration
    * @param newPOP3LogFile
    */
   public void setPOP3LogFile( String newPOP3LogFile )
   {
      POP3LogFile = newPOP3LogFile;
   }


   /**
    * Method declaration
    * @return
    */
   public String getPOP3LogFile()
   {
      return POP3LogFile;
   }


   /**
    * Method declaration
    * @param newSMTPLogFile
    */
   public void setSMTPLogFile( String newSMTPLogFile )
   {
      SMTPLogFile = newSMTPLogFile;
   }


   /**
    * Method declaration
    * @return
    */
   public String getSMTPLogFile()
   {
      return SMTPLogFile;
   }


   /**
    * Method declaration
    * @param newSenderLogFile
    */
   public void setSenderLogFile( String newSenderLogFile )
   {
      senderLogFile = newSenderLogFile;
   }


   /**
    * Method declaration
    * @return
    */
   public String getSenderLogFile()
   {
      return senderLogFile;
   }


   /**
    * Method declaration
    * @param newFetcherLogFile
    */
   public void setFetcherLogFile( String newFetcherLogFile )
   {
      fetcherLogFile = newFetcherLogFile;
   }


   /**
    * Method declaration
    * @return
    */
   public String getFetcherLogFile()
   {
      return fetcherLogFile;
   }


   /**
    * Method declaration
    * @param newStatusLogFile
    */
   public void setStatusLogFile( String newStatusLogFile )
   {
      statusLogFile = newStatusLogFile;
   }


   /**
    * Method declaration
    * @return
    */
   public String getStatusLogFile()
   {
      return statusLogFile;
   }


   /**
    * Method declaration
    * @param newLocalPop3Port
    */
   public void setLocalPop3Port( int newLocalPop3Port )
   {
      localPop3Port = newLocalPop3Port;
   }


   /**
    * Method declaration
    * @return
    */
   public int getLocalPop3Port()
   {
      return localPop3Port;
   }


   /**
    * Method declaration
    * @param newLocalSMTPPort
    */
   public void setLocalSMTPPort( int newLocalSMTPPort )
   {
      localSMTPPort = newLocalSMTPPort;
   }


   /**
    * Method declaration
    * @return
    */
   public int getLocalSMTPPort()
   {
      return localSMTPPort;
   }


   /**
    * Method declaration
    * @param newRemoteSMTPPort
    */
   public void setRemoteSMTPPort( int newRemoteSMTPPort )
   {
      remoteSMTPPort = newRemoteSMTPPort;
   }


   /**
    * Method declaration
    * @return
    */
   public int getRemoteSMTPPort()
   {
      return remoteSMTPPort;
   }


   /**
    * Method declaration
    * @param newRunSenderDaemon
    */
   public void setRunSenderDaemon( boolean newRunSenderDaemon )
   {
      runSenderDaemon = newRunSenderDaemon;
   }


   /**
    * Method declaration
    * @return
    */
   public boolean isRunSenderDaemon()
   {
      return runSenderDaemon;
   }


   /**
    * Method declaration
    * @param newRunFetcherDaemon
    */
   public void setRunFetcherDaemon( boolean newRunFetcherDaemon )
   {
      runFetcherDaemon = newRunFetcherDaemon;
   }


   /**
    * Method declaration
    * @return
    */
   public boolean isRunFetcherDaemon()
   {
      return runFetcherDaemon;
   }


   /**
    * Method declaration
    * @param newUseJDBC
    */
   public void setUseJDBC( boolean newUseJDBC )
   {
      useJDBC = newUseJDBC;
   }


   /**
    * Method declaration
    * @return
    */
   public boolean isUseJDBC()
   {
      return useJDBC;
   }


   /**
    * Method declaration
    * @param newJDBCDriver
    */
   public void setJDBCDriver( String newJDBCDriver )
   {
      JDBCDriver = newJDBCDriver;
   }


   /**
    * Method declaration
    * @return
    */
   public String getJDBCDriver()
   {
      return JDBCDriver;
   }


   /**
    * Method declaration
    * @param newJDBCServerURL
    */
   public void setJDBCURL( String newJDBCServerURL )
   {
      JDBCURL = newJDBCServerURL;
   }


   /**
    * Method declaration
    * @return
    */
   public String getJDBCURL()
   {
      return JDBCURL;
   }


   /**
    * Method declaration
    * @param newUserList
    */
   public void setUserList( java.util.Vector newUserList )
   {
      userList = newUserList;
   }


   /**
    * Method declaration
    * @return
    */
   public java.util.Vector getUserList()
   {
      return userList;
   }


   /**
    * Method declaration
    */
   public void hasChangedSoNotify()
   {
      setChanged();
      notifyObservers( null );
   }


   /**
    * Method declaration
    * @param newAdmin
    */
   public void setAdmin( String newAdmin )
   {
      admin = newAdmin;
   }


   /**
    * Method declaration
    * @return
    */
   public String getAdmin()
   {
      return admin;
   }


   /**
    * Method declaration
    * @param newRemotePopAccounts
    */
   public void setRemotePopAccounts( java.util.Vector newRemotePopAccounts )
   {
      remotePopAccounts = newRemotePopAccounts;
   }


   /**
    * Method declaration
    * @return
    */
   public java.util.Vector getRemotePopAccounts()
   {
      return remotePopAccounts;
   }


   /**
    * Method declaration
    * @param newMailsIn
    */
   public void setMailsIn( long newMailsIn )
   {
      nrOfMailsIn = newMailsIn;
   }


   /**
    * Method declaration
    * @return
    */
   public long getNrOfMailsIn()
   {
      return nrOfMailsIn;
   }


   /**
    * Method declaration
    * @param newMailsOut
    */
   public void setMailsOut( long newMailsOut )
   {
      nrOfMailsOut = newMailsOut;
   }


   /**
    * Method declaration
    * @return
    */
   public long getNrOfMailsOut()
   {
      return nrOfMailsOut;
   }


   /**
    * Method declaration
    * @param newSizeofMailsIn
    */
   public void setSizeofMailsIn( long newSizeofMailsIn )
   {
      sizeofMailsIn = newSizeofMailsIn;
   }


   /**
    * Method declaration
    * @return
    */
   public long getSizeofMailsIn()
   {
      return sizeofMailsIn;
   }


   /**
    * Method declaration
    * @param newSizeofMailsOut
    */
   public void setSizeofMailsOut( long newSizeofMailsOut )
   {
      sizeofMailsOut = newSizeofMailsOut;
   }


   /**
    * Method declaration
    * @return
    */
   public long getSizeofMailsOut()
   {
      return sizeofMailsOut;
   }


   /**
    * Method declaration
    * @param newUpSince
    */
   public void setUpSince( java.util.Date newUpSince )
   {
      upSince = newUpSince;
   }


   /**
    * Method declaration
    * @return
    */
   public java.util.Date getUpSince()
   {
      return upSince;
   }


   /**
    * Method declaration
    * @param newDNServer
    */
   public void setDNServer( String newDNServer )
   {
      DNServer = newDNServer;
   }


   /**
    * Method declaration
    * @return
    */
   public String getDNServer()
   {
      return DNServer;
   }


   /**
    * Method declaration
    * @param delay
    */
   public void setFetcherDelay( int delay )
   {
      fetcherDelay = delay;
   }


   /**
    * Method declaration
    * @return
    */
   public int getFetcherDelay()
   {
      return fetcherDelay;
   }


   /**
    * Method declaration
    * @return
    */
   public int getMaxThreads()
   {
      return maxThreads;
   }


   /**
    * Method declaration
    * @return
    */
   public void setMaxThreads( int maxThreads )
   {
      this.maxThreads = maxThreads;
   }


   /**
    * Method declaration
    * @return
    */
   public String getTransactionLogFile()
   {
      return txLogFile;
   }


   /**
    * Method declaration
    * @param logfile
    */
   public void setTransactionLogFile( String logfile )
   {
      txLogFile = logfile;
   }

   public boolean isShowStatusWindow()
   {
        return showStatusWindow;
   }

   public void setShowStatusWindow(boolean show)
   {
        showStatusWindow = show;
   }


   private String             homeDirectory;
   private String             localDomainName;
   private String             SMTPServer;
   private String             unknownUser;
   private String             POP3LogFile;
   private String             SMTPLogFile;
   private String             senderLogFile;
   private String             fetcherLogFile;
   private String             statusLogFile;
   private String             txLogFile;
   private int                localPop3Port;
   private int                localSMTPPort;
   private int                remoteSMTPPort;
   private boolean            runSenderDaemon;
   private boolean            runFetcherDaemon;
   private boolean            useJDBC;
   private boolean            showStatusWindow;
   private String             JDBCDriver;
   private String             JDBCURL;
   private java.util.Vector   userList;
   private String             admin;
   private java.util.Vector   remotePopAccounts;
   private long               nrOfMailsIn;
   private long               nrOfMailsOut;
   private long               sizeofMailsIn;
   private long               sizeofMailsOut;
   private java.util.Date     upSince;
   private String             DNServer;
   private int                fetcherDelay;
   private int                maxThreads;
}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

