/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/ThreadPoolManager.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: ThreadPoolManager.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package at.jps.mailserver;

/*
 * Copyright (c) 1999 by Johannes Plachy
 */

import java.util.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class ThreadPoolManager
{
   private Vector          m_runnableVector;
   final public static int MAX_THREADS = 10;

   /**
    * create pool of workerthreads for later use
    * @param threadPoolSize number of workerthreads
    */
   public ThreadPoolManager( int threadPoolSize )
   {
      m_runnableVector = new Vector( 1, 10 );

      for ( int ii = 0; ii < threadPoolSize; ii++ )
      {
         new ManagedThread( this );
      }
   }


   /**
    * called by workerthreads that are not busy at the moment
    * @param ManagedThread that needs something to do
    */
   void threadWaiting( ManagedThread mt ) throws InterruptedException
   {
      while ( 0 == m_runnableVector.size() )
      {
         wait();
      }

      Runnable r = ( Runnable )m_runnableVector.elementAt( 0 );

      m_runnableVector.removeElementAt( 0 );
      mt.startRunnable( r );
   }


   /**
    * a new task that has to be worked on by a workerthread is added to the internal queue and later assigned to the
    * first thread that has time.
    * @param Runnable - the new task
    */
   public void addRequest( Runnable r )
   {
      m_runnableVector.addElement( r );
      notifyAll();
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

