/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/User.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: User.java,v $
* Revision 1.3  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;

import java.io.Serializable;

/**
 * User Creates an User with name and password
 * (c) 1998 Computer Mutter computer@mutter.com
 * Adapted 1999 - 2002 by Johannes Plachy
 */
final public class User implements Serializable
{
   private String ivUsername;
   private String ivPassword;
   private int ivUserId;

   /**
    * Constructor declaration
    * @param user
    * @param pass
    */
   public User( String username, String password, int userId )
   {
      setUsername( username );
      setPassword( password );
      setUserId( userId);
   }

   // for backward compatibility
   public User( String username, String password )
   {
      setUsername( username );
      setPassword( password );
      setUserId( 0);
   }

   /**
    * Compares two Objects for equality. Returns a boolean that indicates whether this Object is equivalent
    * to the specified Object. This method is used when an Object is stored in a hashtable.
    * @param    obj     the Object to compare with
    * @return   true if these Objects are equal; false otherwise.
    * @see              java.util.Hashtable
    */
   final public boolean equals( Object obj )
   {
      String   user1 = getUsername();
      User     user2 = ( User )obj;

      if ( ( user1 == null ) && ( user2 == null ) )
      {
         return true;
      }

      if ( ( user1 != null ) && ( user2 != null ) )
      {
         return user2.getUsername().equals( user1 );
      }
      else
      {
         return false;
      }
   }


   /**
    * Method declaration
    * @return
    */
   final public String getPassword()
   {
      String   result = null;

      if ( ivPassword != null )
      {
         result = ivPassword.toLowerCase();
      }

      return result;
   }


   /**
    * Method declaration
    * @return
    */
   final public String getUsername()
   {
      String   result = null;

      if ( ivUsername != null )
      {
         result = ivUsername.toLowerCase();
      }

      return result;
   }


   /**
    * Generates a hash code for the receiver. This method is supported primarily for hash tables, such as
    * those provided in java.util.
    * @return   an integer hash code for the receiver
    * @see              java.util.Hashtable
    */
   final public int hashCode()
   {
      return super.hashCode();
   }


   /**
    * Method declaration
    * @param pass
    */
   final public void setPassword( String password )
   {
      ivPassword = password;
   }


   /**
    * Method declaration
    * @param user
    */
   final public void setUsername( String userName )
   {
      ivUsername = userName;
   }

   public int getUserId()
   {
       return ivUserId;
   }

   public void setUserId(int userid)
   {
        ivUserId = userid;
   }

   /**
    * Returns a String that represents the value of this object.
    */
   final public String toString()
   {

      // insert code to print the receiver here
      // this implementation simply forwards the message to super.  You may replace or supplement this.

      return getUsername() + " " + getPassword()+ " UID:"+ getUserId();
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

