/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/UserHandler.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: UserHandler.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;


interface UserHandler
{
    boolean addUser( String username, String password );

    /**
     * try to find a user in the internal list
     * @param username
     * @return true if user exists
     */
    boolean existsUser( String username );

    boolean deleteUser( String username );

    String getPassword( String username );

    boolean validatePassword( String username, String password);

    /**
     * change password for existing user
     * @param username
     * @param password
     */
    public void setPassword( String username, String password );


    /**
     * retrieve UserId
     *
     * @return userid
     */
    User getUserByName(String username);
    User getUserByAlias(String alias);

    String getReceiverName( String UserOrAlias );
    User getReceiver( String UserOrAlias );

}

