
/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/UserHandlerFile.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:07:13 $
*
* modification history:
*
* $Log: UserHandlerFile.java,v $
* Revision 1.2  2002/01/20 16:07:13  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver;


public class UserHandlerFile extends UserHandlerImpl
{

    UserHandlerFile( ConfigurationManager configurationManager )
    {
        super( configurationManager );
    }

    private UserList getUserList()
    {
        return getConfiguration().getUserList();
    }

    public boolean addUser( String username, String password )
    {
        getUserList().addUser( username, password );
        return true;
    }

    /**
     * try to find a user in the internal list
     * @param username
     * @return true if user exists
     */
    public boolean existsUser( String username )
    {
        return getUserList().contains( username );
    }

    public boolean deleteUser( String username )
    {
        return getUserList().delUser( username );
    }

    public String getPassword( String username )
    {
        return getUserList().getPassword( username );
    }

    public boolean validatePassword( String username, String password)
    {
        return getPassword( username ).equalsIgnoreCase(password);
    }

    /**
     * change password for existing user
     * @param username
     * @param password
     */
    public void setPassword( String username, String password )
    {
        getUserList().setPassword( username, password );
    }


    /**
     * retrieve UserId
     *
     * @return userid
     */
    public User getUserByName( String username)
    {
        return getUserList().getUserByName( username);
    }

    public User getUserByAlias( String alias)
    {
        return getUserByName( getConfiguration().getAliasList().getAlias( alias));
    }

    public User getReceiver( String userOrAlias )
    {
        return getUserByName( getReceiverName( userOrAlias ));
    }

    public String getReceiverName( String userOrAlias )
    {
        // first check if user
        if ( existsUser( userOrAlias ) == false )
        {
            // else look for alias
            userOrAlias = getConfiguration().getAliasList().getAlias( userOrAlias );

            if ( userOrAlias == null )
            {
                // in any other case the default mail user is taken
                userOrAlias = getConfiguration().getUnknownUsername();
            }
        }

        return userOrAlias.toLowerCase();
    }

}

