/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

package at.jps.mailserver.gui;

import java.awt.*;
import java.awt.event.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class HelpAboutDialog extends Dialog implements ActionListener, WindowListener, KeyListener
{
   static public String CLOSE = "Close";
   static public String versionString = "0.99.s";
   static String        text[] =
   {
      "Java Mail Server", "by Johannes Plachy", "One Step Ahead", "http://www.jps.at/java/tools/mailserver.html", "(version " + versionString + ")", "", "This program is free software", "and is distributed under the terms", "of the GNU General Public License.", "View the file 'gpl.html' for more information."
   };
   static Font          fonts[] =
   {
      new Font( "Monospaced", Font.BOLD + Font.ITALIC, 28 ), new Font( "Monospaced", Font.ITALIC, 12 ), new Font( "Monospaced", Font.BOLD, 20 ), new Font( "Monospaced", Font.PLAIN, 12 ), new Font( "Monospaced", Font.BOLD, 12 ), null, new Font( "Serif", Font.PLAIN, 12 ), new Font( "Serif", Font.PLAIN, 12 ), new Font( "Serif", Font.PLAIN, 12 ), new Font( "Serif", Font.PLAIN, 12 )
   };
   static Color         colors[] =
   {
      Color.red, new Color( 0, 0, 128 ),     // navyBlue
      new Color( 0, 255, 255 ),              // lightBlue
      new Color( 0, 0, 128 ),                // navyBlue
      new Color( 0, 0, 128 ),                // navyBlue
      null, new Color( 0, 0, 64 ),           // midnightBlue
      new Color( 0, 0, 64 ),                 // midnightBlue
      new Color( 0, 0, 64 ),                 // midnightBlue
      new Color( 0, 0, 64 )                  // midnightBlue
   };

   /**
    * Constructor declaration
    * @param parent
    * @param title
    * @param modal
    */
   private HelpAboutDialog( Frame parent, String title, boolean modal )
   {
      super( parent, title, modal );

      addWindowListener( this );
      addKeyListener( this );
      setTitle( title );
      setLayout( new BorderLayout( 10, 10 ) );

      Panel messagePanel = createMultiLinePanel( text, fonts, colors );

      add( "Center", messagePanel );

      // Panel centerPanel = new Panel();
      // Canvas imageCanvas = new ImageCanvas(Resources.appIcon);
      // centerPanel.add(imageCanvas);
      // centerPanel.add(messagePanel);
      // add("Center", centerPanel);

      Panel    buttonPanel = new Panel();
      Button   button = new Button( "Close" );

      button.addActionListener( this );
      button.addKeyListener( this );
      buttonPanel.add( button );
      add( "South", buttonPanel );
      pack();
   }


   // ---------- ActionListener Implementation ---------------

   /**
    * Method declaration
    * @param evt
    */
   public void actionPerformed( ActionEvent evt )
   {
      setVisible( false );
      dispose();
   }


   // ---------- WindowListener Implementatons ---------------

   /**
    * Method declaration
    * @param evt
    */
   public void windowClosing( WindowEvent evt )
   {
      fireCloseRequested();
   }


   /**
    * Method declaration
    * @param evt
    */
   public void windowClosed( WindowEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void windowDeiconified( WindowEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void windowIconified( WindowEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void windowOpened( WindowEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void windowActivated( WindowEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void windowDeactivated( WindowEvent evt ) {}


   // ---------- KeyListener Implementation ------------------

   /**
    * Method declaration
    * @param evt
    */
   public void keyPressed( KeyEvent evt )
   {
      if ( ( evt.getKeyCode() == KeyEvent.VK_ESCAPE ) || ( evt.getKeyCode() == KeyEvent.VK_ENTER ) || ( evt.getKeyCode() == KeyEvent.VK_SPACE ) )
      {
         fireCloseRequested();
      }
   }


   /**
    * Method declaration
    * @param evt
    */
   public void keyReleased( KeyEvent evt ) {}


   /**
    * Method declaration
    * @param evt
    */
   public void keyTyped( KeyEvent evt ) {}


   /**
    * Method declaration
    */
   private void fireCloseRequested()
   {
      actionPerformed( new ActionEvent( this, ActionEvent.ACTION_PERFORMED, CLOSE ) );
   }


   // ---------- Private Methods -----------------------------

   /**
    * Method declaration
    * @param text
    * @param fonts
    * @param colors
    * @return
    */
   private Panel createMultiLinePanel( String[] text, Font[] fonts, Color[] colors )
   {
      Panel          mainPanel = new Panel();
      GridBagLayout  gbLayout = new GridBagLayout();

      mainPanel.setLayout( gbLayout );
      addMultilineString( text, fonts, colors, mainPanel );

      return mainPanel;
   }


   /**
    * Method declaration
    * @param lines
    * @param fonts
    * @param colors
    * @param container
    */
   private void addMultilineString( String[] lines, Font[] fonts, Color[] colors, Container container )
   {
      GridBagConstraints   constraints = getDefaultConstraints();
      GridBagLayout        gbLayout = ( GridBagLayout )container.getLayout();

      for ( int i = 0; i < lines.length; i++ )
      {
         Label label = new Label( lines[ i ], Label.CENTER );

         if ( fonts[ i ] != null )
         {
            label.setFont( fonts[ i ] );
         }

         if ( colors[ i ] != null )
         {
            label.setForeground( colors[ i ] );
         }

         gbLayout.setConstraints( label, constraints );
         container.add( label );
      }
   }


   /**
    * Method declaration
    * @return
    */
   private GridBagConstraints getDefaultConstraints()
   {
      GridBagConstraints   constraints = new GridBagConstraints();

      constraints.weightx = 1.0;
      constraints.weighty = 1.0;
      constraints.gridwidth = GridBagConstraints.REMAINDER;
      constraints.gridheight = 1;
      constraints.ipadx = 0;
      constraints.ipady = 0;
      constraints.insets = new Insets( 0, 0, 0, 0 );
      constraints.fill = GridBagConstraints.NONE;
      constraints.anchor = GridBagConstraints.CENTER;

      return constraints;
   }


   /**
    * Method declaration
    * @param win
    */
   static public void centerWindow( Window win )
   {
      Dimension   screenDim = Toolkit.getDefaultToolkit().getScreenSize();

      // If larger than screen, reduce window width or height

      if ( screenDim.width < win.getSize().width )
      {
         win.setSize( screenDim.width, win.getSize().height );
      }

      if ( screenDim.height < win.getSize().height )
      {
         win.setSize( win.getSize().width, screenDim.height );
      }

      // Center Frame, Dialogue or Window on screen

      int   x = ( screenDim.width - win.getSize().width ) / 2;
      int   y = ( screenDim.height - win.getSize().height ) / 2;

      win.setLocation( x, y );
   }


   /**
    * @param comp
    * @param minWidth
    * @param minHeight
    */
   static private void enforceMinimumSize( Component comp, int minWidth, int minHeight )
   {
      if ( comp.getSize().width < minWidth )
      {
         comp.setSize( minWidth, comp.getSize().height );
      }

      if ( comp.getSize().height < minHeight )
      {
         comp.setSize( comp.getSize().width, minHeight );
      }
   }


   /**
    * Method declaration
    * @param parent
    * @param title
    * @param modal
    */
   static public void showDialog( Frame parent, String title, boolean modal )
   {
      HelpAboutDialog   dialog = new HelpAboutDialog( parent, title, modal );

      enforceMinimumSize( dialog, 200, 100 );
      centerWindow( dialog );
      dialog.setVisible( true );
   }


   /**
    * @param parent
    * @param title
    * @param modal
    * @param delay
    */
   static public void showTimedDialog( Frame parent, String title, boolean modal, int delay )
   {
      final HelpAboutDialog   dialog = new HelpAboutDialog( parent, title, modal );
      final long              delayMS = delay * 1000L;

      enforceMinimumSize( dialog, 200, 100 );
      centerWindow( dialog );
      new Thread( new Runnable()
      {

         /**
          * Method declaration
          */
         public void run()
         {
            long  start = System.currentTimeMillis();
            long  end = start + delayMS;

            while ( System.currentTimeMillis() < end )
            {
               try
               {
                  Thread.sleep( end - System.currentTimeMillis() );
               }
               catch ( InterruptedException e ) {}
            }

            if ( dialog.isVisible() )
            {
               dialog.setVisible( false );
               dialog.dispose();
            }
         }


      } ).start();
      dialog.setVisible( true );
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

