/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/gui/SettingsApplet.java,v $
*
* $Author: furykid $
* $Date: 2003/04/01 19:08:17 $
*
* modification history:
*
* $Log: SettingsApplet.java,v $
* Revision 1.3  2003/04/01 19:08:17  furykid
* cleanup
*
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.gui;

import at.jps.mailserver.Settings;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.UIManager;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class SettingsApplet extends JApplet
{
   boolean  isStandalone = false;
   Settings ivSettings = null;

   // Get a parameter value

   /**
    * Method declaration
    * @param key
    * @param def
    * @return
    */
   public String getParameter( String key, String def )
   {
      return isStandalone ? System.getProperty( key, def ) : ( getParameter( key ) != null ? getParameter( key ) : def );
   }


   // Construct the applet

   /**
    * Constructor declaration
    */
   public SettingsApplet() {}


   // Initialize the applet

   /**
    * Method declaration
    */
   public void init()
   {
      try
      {
         jbInit();
      }
      catch ( Exception e )
      {
         e.printStackTrace();
      }
   }


   /**
    * Method declaration
    */
   private void getSettings()
   {
      try
      {
         URL            homeURL = getCodeBase();
         URL            url = new URL( "http", homeURL.getHost(), homeURL.getPort(), getParameter( "ServletPath", "/servlets/MailServerServlet" ) );
         URLConnection  urlConnection = url.openConnection();

         urlConnection.setDoInput( true );
         urlConnection.setDoOutput( true );
         urlConnection.setUseCaches( false );
         urlConnection.setDefaultUseCaches( false );

         // urlConnection.connect();
         // Open data output stream

         ObjectOutputStream   outputStream = new ObjectOutputStream( urlConnection.getOutputStream() );

         // null will tell the server to send settings back !!

         outputStream.writeObject( null );
         outputStream.close();

         ObjectInputStream inputStream = new ObjectInputStream( urlConnection.getInputStream() );

         // read last standing

         ivSettings = ( Settings )inputStream.readObject();

         // System.out.println("\nread: "+reversiStatus);

         inputStream.close();
      }
      catch ( MalformedURLException mfux )
      {

         // set_statistic( "MalformedURLException");

         System.err.println( mfux );
      }
      catch ( IOException iox )
      {

         // set_statistic( "IOException");

         System.err.println( iox );
         iox.printStackTrace();
      }
      catch ( ClassNotFoundException cnfx )
      {

         // set_statistic( "ClassNotFoundException");

         System.err.println( cnfx );
      }
      catch ( java.security.AccessControlException acx )
      {

         // set_statistic( "AccessControlException");

         System.err.println( acx );
      }
   }


   // Component initialization

   /**
    * Method declaration
    * @throws Exception
    */
   private void jbInit() throws Exception
   {

      // this.setSize(new Dimension(400,300));
      // get settings from servlet

      getSettings();
      add( new SettingsPanel( ivSettings, true, null ) );
   }


   // Start the applet

   /**
    * Method declaration
    */
   public void start() {}


   // Stop the applet

   /**
    * Method declaration
    */
   public void stop() {}


   // Destroy the applet

   /**
    * Method declaration
    */
   public void destroy() {}


   // Get Applet information

   /**
    * Method declaration
    * @return
    */
   public String getAppletInfo()
   {
      return "Java Mailserver Remote Administration";
   }


   // Get parameter info

   /**
    * Method declaration
    * @return
    */
   public String[][] getParameterInfo()
   {
      return null;
   }


   // Main method

   /**
    * Method declaration
    * @param args
    */
   public static void main( String[] args )
   {
      SettingsApplet applet = new SettingsApplet();

      applet.isStandalone = true;

      JFrame   frame = new JFrame();

      frame.setTitle( "Applet Frame" );
      frame.getContentPane().add( applet, BorderLayout.CENTER );
      applet.init();
      applet.start();
      frame.setSize( 400, 320 );

      Dimension   d = Toolkit.getDefaultToolkit().getScreenSize();

      frame.setLocation( ( d.width - frame.getSize().width ) / 2, ( d.height - frame.getSize().height ) / 2 );
      frame.setVisible( true );
   }


   // static initializer for setting look & feel

   static
   {
      try
      {
         UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );

         // UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());

      }
      catch ( Exception e ) {}
   }
}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

