/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/gui/StatusFrame.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: StatusFrame.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.gui;

import at.jps.mailserver.*;
import at.jps.mailserver.gui.performance.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class StatusFrame extends JFrame implements MailStatisticsListener, TXMsgListener
{
   private JTextField   jtxtfldMailIn = new JTextField();
   private JLabel       jLabel2 = new JLabel();
   private JTextField   jtxtfldMailOut = new JTextField();

   // private ImageIcon            bulb_off = new ImageIcon( "gui/bulb_off.gif", "off" );

   private JScrollPane  jScrollPane1 = new JScrollPane();
   private JTextArea    jTextArea = new JTextArea();
   static StatusFrame   instance = null;
   JMenu                jMenu1 = new JMenu();
   JMenu                jMenu2 = new JMenu();
   JMenuBar             jMenuBar1 = new JMenuBar();
   JMenuItem            jmnuExit = new JMenuItem();
   JCheckBoxMenuItem    jmnuBusyMon = new JCheckBoxMenuItem();
   JCheckBoxMenuItem    jmnuMemMon = new JCheckBoxMenuItem();
   BusyMonitorWindow    bmw = null;
   MemoryMonitorWindow  mmw = null;
   boolean              bmw_visible = false;
   boolean              mmw_visible = false;
   JLabel               jLabel3 = new JLabel();
   JCheckBox            jchkbxSender = new JCheckBox();
   JCheckBox            jchkbxFetcher = new JCheckBox();
   GridBagLayout        gridBagLayout1 = new GridBagLayout();

   /**
    * Constructor declaration
    */
   public StatusFrame()
   {
      MailStatistic.getInstance().addListener( this );
      ErrorReporter.getInstance().setTXMsgListener( this );

      try
      {
         jbInit();
      }
      catch ( Exception e )
      {
         e.printStackTrace();
      }
   }


   /**
    * Method declaration
    * @return
    */
   public static StatusFrame getInstance()
   {
      if ( instance == null )
      {
         instance = new StatusFrame();
      }

      return instance;
   }


   /**
    * Method declaration
    * @throws Exception
    */
   private void jbInit() throws Exception
   {
      this.getContentPane().setLayout( gridBagLayout1 );
      jtxtfldMailIn.setBorder( null );
      jtxtfldMailIn.setToolTipText( "mail traffic" );
      jtxtfldMailIn.setEditable( false );
      jtxtfldMailIn.setText( "0" );
      jtxtfldMailIn.setHorizontalAlignment( SwingConstants.RIGHT );
      jLabel2.setText( "Mail out:" );
      jtxtfldMailOut.setBorder( null );
      jtxtfldMailOut.setToolTipText( "mail traffic" );
      jtxtfldMailOut.setEditable( false );
      jtxtfldMailOut.setText( "0" );
      jtxtfldMailOut.setHorizontalAlignment( SwingConstants.RIGHT );

      // jchbxSender.setText("Sender running");
      // jchbxFetcher.setText("Fetcher running");

      this.setJMenuBar( jMenuBar1 );
      this.setResizable( false );
      this.setTitle( "Java Mail Server Status" );
      this.addWindowListener( new java.awt.event.WindowAdapter()
      {

         /**
          * Method declaration
          * @param e
          */
         public void windowClosing( WindowEvent e )
         {
            this_windowClosing( e );
         }


      } );
      jMenu1.setText( "File" );
      jMenu2.setText( "Performance" );
      jmnuExit.setText( "hide" );
      jmnuExit.addActionListener( new java.awt.event.ActionListener()
      {

         /**
          * Method declaration
          * @param e
          */
         public void actionPerformed( ActionEvent e )
         {
            jmnuExit_actionPerformed( e );
         }


      } );
      jmnuBusyMon.setText( "BusyMonitor" );
      jmnuBusyMon.addActionListener( new java.awt.event.ActionListener()
      {

         /**
          * Method declaration
          * @param e
          */
         public void actionPerformed( ActionEvent e )
         {
            jmnuBusyMon_actionPerformed( e );
         }


      } );
      jmnuMemMon.setText( "MemoryMonitor" );
      jmnuMemMon.addActionListener( new java.awt.event.ActionListener()
      {

         /**
          * Method declaration
          * @param e
          */
         public void actionPerformed( ActionEvent e )
         {
            jmnuMemMon_actionPerformed( e );
         }


      } );
      jTextArea.setEditable( false );
      jLabel3.setText( "Mail in:" );
      jchkbxSender.setToolTipText( "if checked outgoing mail will be delivered as soon as it arives" );
      jchkbxSender.setText( "Sender daemon running" );
      jchkbxSender.setActionCommand( "jchkbxSender" );
      jchkbxFetcher.setActionCommand( "jchkbxFetcher" );
      jchkbxFetcher.setText( "Fetcher daemon running" );
      jchkbxFetcher.setToolTipText( "if checked outgoing mail will becollected from one or more remote " + "POP accounts" );
      this.getContentPane().add( jScrollPane1, new GridBagConstraints( 0, 2, 3, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 0, 6, 6, 8 ), 457, 105 ) );
      jScrollPane1.getViewport().add( jTextArea, null );
      this.getContentPane().add( jLabel2, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 0, 7 ) );
      this.getContentPane().add( jtxtfldMailIn, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 5, 0, 0, 0 ), 33, 0 ) );
      this.getContentPane().add( jtxtfldMailOut, new GridBagConstraints( 1, 1, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets( 7, 0, 0, 0 ), 33, 0 ) );
      this.getContentPane().add( jLabel3, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 5, 6, 0, 6 ), 0, 7 ) );
      this.getContentPane().add( jchkbxSender, new GridBagConstraints( 2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 5, 17, 0, 202 ), 0, 0 ) );
      this.getContentPane().add( jchkbxFetcher, new GridBagConstraints( 2, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets( 0, 17, 0, 201 ), 0, 0 ) );
      jMenu1.add( jmnuExit );
      jMenu2.add( jmnuBusyMon );
      jMenu2.add( jmnuMemMon );
      jMenuBar1.add( jMenu1 );
      jMenuBar1.add( jMenu2 );
      pack();

      Dimension   screen = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension   win = getPreferredSize();

      setLocation( screen.width - win.width, screen.height - win.height );

      setIconImage( new ImageIcon( getClass().getResource( "images/mailserver.gif" ), "Mailserver Icon" ).getImage() );

      setVisible( true );

      HelpAboutDialog.showTimedDialog( this, "About Java Mailserver", false, 5 );

      updateDamonStatus();
   }


   /**
    * Method declaration
    */
   private void updateDamonStatus()
   {
      jchkbxSender.setSelected( MailStatistic.getInstance().getConfiguration().isSenderRunning() );
      jchkbxFetcher.setSelected( MailStatistic.getInstance().getConfiguration().isFetcherRunning() );

      jchkbxSender.setEnabled( false);
      jchkbxFetcher.setEnabled( false);

   }


   /**
    * Method declaration
    * @param newSize
    */
   public void outgoingMailSizeChanged( long newSize )
   {

      // NYI

   }


   /**
    * Method declaration
    * @param newSize
    */
   public void incomingMailSizeChanged( long newSize )
   {

      // NYI

   }


   /**
    * Method declaration
    * @param newNumber
    */
   public void outgoingMailAmountChanged( long newNumber )
   {
      jtxtfldMailOut.setText( Long.toString( newNumber ) );
   }


   /**
    * Method declaration
    * @param newNumber
    */
   public void incomingMailAmountChanged( long newNumber )
   {
      jtxtfldMailIn.setText( Long.toString( newNumber ) );
   }


   /**
    * Method declaration
    * @param line
    */
   public void lineAdded( String line )
   {
      jTextArea.append( line );
   }


   /**
    * Method declaration
    * @param e
    */
   void this_windowClosing( WindowEvent e )
   {
      MailStatistic.getInstance().removeListener( this );
      ErrorReporter.getInstance().removeTXMsgListener();

      // System.exit( 0 );

      setVisible( false );
   }


   /**
    * Method declaration
    * @param show
    */
   public static void showStatusWindow( boolean show )
   {
      getInstance().setVisible( show );
   }


   /**
    * Method declaration
    * @param e
    */
   void jmnuBusyMon_actionPerformed( ActionEvent e )
   {
      bmw_visible = !bmw_visible;

      jmnuBusyMon.setSelected( bmw_visible );

      if ( bmw == null )
      {
         bmw = new BusyMonitorWindow( this );
      }

      if ( bmw_visible )
      {
         bmw.show();
      }
      else
      {
         bmw.setVisible( false );
      }
   }


   /**
    * Method declaration
    * @param e
    */
   void jmnuMemMon_actionPerformed( ActionEvent e )
   {
      mmw_visible = !mmw_visible;

      jmnuMemMon.setSelected( mmw_visible );

      if ( mmw == null )
      {
         mmw = new MemoryMonitorWindow( this );
      }

      if ( mmw_visible )
      {
         mmw.show();
      }
      else
      {
         mmw.setVisible( false );
      }
   }


   /**
    * Method declaration
    * @param e
    */
   void jmnuExit_actionPerformed( ActionEvent e )
   {
      this_windowClosing( null );
   }


   /**
    * Method declaration
    * @param args
    */
   public static void main( String args[] )
   {
      new StatusFrame();

   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

