/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Copyright (c) 1999 / 2000  Johannes Plachy & Computer Mutter
 *
 * JMailSrv@jps.at
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * If you modify this file, please send us a copy.
 */

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/gui/performance/MemoryMonitorWindow.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: MemoryMonitorWindow.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.gui.performance;

import java.awt.*;
import java.awt.event.*;

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class MemoryMonitorWindow extends Window
{

   /**
    * Constructor declaration
    * @param frame
    */
   public MemoryMonitorWindow( Frame frame )
   {
      super( frame );

      setLayout( new FlowLayout() );
      setBackground( SystemColor.menu );
      add( new MemoryMonitor() );
      setSize( 1, 1 );     // bug fix for Linux:  Window not displaying
      pack();

      Dimension   screen = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension   win = getPreferredSize();

      setLocation( screen.width - win.width, 50 );
      show();
      addWindowListener( new WindowAdapter()
      {

         /**
          * Method declaration
          * @param e
          */
         public void windowClosing( WindowEvent e )
         {
            setVisible( false );
            dispose();
         }


      } );
   }


   /**
    * Method declaration
    * @param g
    */
   public void update( Graphics g )
   {
      paint( g );
   }


   /**
    * Method declaration
    * @param g
    */
   public void paint( Graphics g )
   {
      int   w = getSize().width;
      int   h = getSize().height;
      int   m = Math.min( w, h ) / 2;
      int   upperX[] =
      {
         0, w, w - m, m, 0
      };
      int   upperY[] =
      {
         0, 0, m, h - m, h
      };
      int   lowerX[] =
      {
         0, m, w - m, w, w
      };
      int   lowerY[] =
      {
         h, h - m, m, 0, h
      };

      g.setColor( getBackground().brighter() );
      g.fillPolygon( upperX, upperY, upperX.length );
      g.setColor( getBackground().darker() );
      g.fillPolygon( lowerX, lowerY, lowerX.length );
   }


   /**
    * Method declaration
    * @param args
    */
   public static void main( String[] args )
   {
      Frame frame = new Frame( "MemoryMonitor test" );

      frame.pack();
      frame.show();
      frame.addWindowListener( new WindowAdapter()
      {

         /**
          * Method declaration
          * @param e
          */
         public void windowClosing( WindowEvent e )
         {
            System.exit( 0 );
         }


      } );

      MemoryMonitorWindow  perf = new MemoryMonitorWindow( frame );
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

