/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/util/CondVar.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: CondVar.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.util;

/*
 * Copyright (c) 1999 by Johannes Plachy
 */

/**
 * Class declaration
 * @author
 * @version %I%, %G%
 */
public class CondVar
{
   private BusyFlag  ivSyncVar;

   /**
    * Constructor declaration
    */
   public CondVar()
   {
      this( new BusyFlag() );
   }


   /**
    * Constructor declaration
    * @param sv
    */
   public CondVar( BusyFlag sv )
   {
      ivSyncVar = sv;
   }


   /**
    * Method declaration
    * @throws InterruptedException
    */
   public void cvWait() throws InterruptedException
   {
      cvTimedWait( ivSyncVar, 0 );
   }


   /**
    * Method declaration
    * @param sv
    * @throws InterruptedException
    */
   public void cvWait( BusyFlag sv ) throws InterruptedException
   {
      cvTimedWait( sv, 0 );
   }


   /**
    * Method declaration
    * @param millis
    * @throws InterruptedException
    */
   public void cvTimedWait( int millis ) throws InterruptedException
   {
      cvTimedWait( ivSyncVar, millis );
   }


   /**
    * Method declaration
    * @param sv
    * @param millis
    * @throws InterruptedException
    */
   public void cvTimedWait( BusyFlag sv, int millis ) throws InterruptedException
   {
      int                  i = 0;
      InterruptedException errex = null;

      synchronized ( this )
      {

         // You must own the lock in order to use this method

         if ( sv.getBusyFlagOwner() != Thread.currentThread() )
         {
            throw new IllegalMonitorStateException( "current thread not owner" );
         }

         // Release the lock (Completely)

         while ( sv.getBusyFlagOwner() == Thread.currentThread() )
         {
            i++;

            sv.freeBusyFlag();
         }

         // Use wait() method

         try
         {
            if ( millis == 0 )
            {
               wait();
            }
            else
            {
               wait( millis );
            }
         }
         catch ( InterruptedException iex )
         {
            errex = iex;
         }
      }

      // Obtain the lock (Return to original state)

      for ( ; i > 0; i-- )
      {
         sv.getBusyFlag();
      }

      if ( errex != null )
      {
         throw errex;
      }

      return;
   }


   /**
    * Method declaration
    */
   public void cvSignal()
   {
      cvSignal( ivSyncVar );
   }


   /**
    * Method declaration
    * @param sv
    */
   public synchronized void cvSignal( BusyFlag sv )
   {

      // You must own the lock in order to use this method

      if ( sv.getBusyFlagOwner() != Thread.currentThread() )
      {
         throw new IllegalMonitorStateException( "current thread not owner" );
      }

      notify();
   }


   /**
    * Method declaration
    */
   public void cvBroadcast()
   {
      cvBroadcast( ivSyncVar );
   }


   /**
    * Method declaration
    * @param sv
    */
   public synchronized void cvBroadcast( BusyFlag sv )
   {

      // You must own the lock in order to use this method

      if ( sv.getBusyFlagOwner() != Thread.currentThread() )
      {
         throw new IllegalMonitorStateException( "current thread not owner" );
      }

      notifyAll();
   }


}



/*--- formatting done in "JPS Convention" style on 08-20-2001 ---*/

