
/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/util/JDBCConfig.java,v $
*
* $Author: furykid $
* $Date: 2003/05/29 18:04:48 $
*
* modification history:
*
* $Log: JDBCConfig.java,v $
* Revision 1.5  2003/05/29 18:04:48  furykid
* rebuild 290503
*
* Revision 1.4  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.util;

import java.sql.*;
import java.util.*;

public class JDBCConfig
{
    //private static String JDBCUrl;

    private static Connection SQLconnection = null;



    public static boolean testConnection( String driverClass ) throws ClassNotFoundException, IllegalAccessException, InstantiationException
    {
       Class.forName( driverClass ).newInstance();

       Properties  P = System.getProperties();

       P.put( "jdbc.drivers", driverClass );

       // register JDBC driver

       System.setProperties( P );

       return true;
    }

    /**
     * gets JDBC driver class and the URL to access the server from the configuration file
     * and tries to instantiate the driver,
     * @param ConfigurationManager to access the configuration information
     */
    public static Connection getConnection( String driverClass, String JDBCUrl ) throws ClassNotFoundException, IllegalAccessException, SQLException, InstantiationException
    {
       if (isConnected() == false)
       {
          testConnection( driverClass );

          SQLconnection = DriverManager.getConnection( JDBCUrl );
       }
       return SQLconnection;

    }

    public static boolean isConnected()
    {
       try
       {
          return ( ( SQLconnection != null ) && ( !SQLconnection.isClosed() ) );
       }
       catch ( SQLException sqlx )
       {
          // nothing to do here
       }

       return false;
    }

    public static Connection getConnection()
    {
        if (isConnected() == true)
        {
            return SQLconnection;
        }
        else
            return null;

    }

}
