/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/mailserver/util/SimpleCache.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: SimpleCache.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/


package at.jps.mailserver.util;

import java.util.*;

class SimpleCache
{
    public static int MAX_CACHE_SIZE = 100;

    private List cachedElements = null;
    private int usedCacheSize = 0;

    SimpleCache()
    {
        usedCacheSize = MAX_CACHE_SIZE;
    }

    SimpleCache(int maxSize)
    {
        usedCacheSize = maxSize;
    }

    private void initializeCache()
    {
        cachedElements = new LinkedList();
    }

    void addElement( Object element)
    {
        if (cachedElements == null)
        {
            initializeCache();
        }
        else
        {
            if (cachedElements.size() == usedCacheSize )
            {
                cachedElements.remove(0);
            }
        }

        cachedElements.add( element);
    }

    void clearCache()
    {
        cachedElements.clear();
    }


}
