/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/threadpool/Queue.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: Queue.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/

package at.jps.threadpool;

import java.io.Serializable;
import java.util.*;

/**
 * synchronized list of objects
 * works stack-like
 *
 * @author Johannes Plachy
 * @version 1.0
 */
public class Queue implements Serializable
{

    private List list = new ArrayList();

    /**
     * add Object to list
     *
     * @param obj    element
     */
    synchronized public void put( Object obj)
    {
        list.add( obj);
        notify();
    }

    /**
     * suspend thread and wait for an object to be available
     *
     * @return a task in our scenario
     */
    synchronized public Object get()
    {
        while (list.isEmpty())
        {
            try
            {
                wait();
            }
            catch ( InterruptedException x)
            {
            }
        }
        return list.remove( 0);
    }


}
