/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/threadpool/ThreadPoolTest.java,v $
*
* $Author: furykid $
* $Date: 2003/05/02 22:06:50 $
*
* modification history:
*
* $Log: ThreadPoolTest.java,v $
* Revision 1.4  2003/05/02 22:06:50  furykid
* fixed eclipse warnings
*
* Revision 1.3  2003/04/01 19:08:21  furykid
* cleanup
*
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/

package at.jps.threadpool;


public class ThreadPoolTest
{


    class ExceptionTest implements Runnable
    {
        /**
         * When an object implementing interface <code>Runnable</code> is used
         * to create a thread, starting the thread causes the object's
         * <code>run</code> method to be called in that separately executing
         * thread.
         * <p>
         * The general contract of the method <code>run</code> is that it may
         * take any action whatsoever.
         *
         * @see     java.lang.Thread#run()
         */
        public void run()
        {
            System.out.println( Thread.currentThread().getName()+" ----- STARTED ! -------");

            try
            {
                Thread.sleep( 1000);
            }
            catch (Exception x)
            {
                throw new Error(" ERROR 1");
            }

            // System.out.println( Thread.currentThread().getName()+" ----- FINISHED ! -------");

            throw new Error("ERROR 2");


        }
    }

    class RunnableTest implements Runnable
    {
        /**
         * When an object implementing interface <code>Runnable</code> is used
         * to create a thread, starting the thread causes the object's
         * <code>run</code> method to be called in that separately executing
         * thread.
         * <p>
         * The general contract of the method <code>run</code> is that it may
         * take any action whatsoever.
         *
         * @see     java.lang.Thread#run()
         */

        int id;

        RunnableTest( int id)
        {
            this.id = id;
        }

        public void run()
        {
            System.out.println( Thread.currentThread().getName()+" ----- STARTED ! -------"+id);

            for (int i = 0; i < 100; i++)
            {
                System.out.println( Thread.currentThread().getName()+ " - "+i);
            }
            System.out.println( Thread.currentThread().getName()+" ----- FINISHED ! -------"+id);
        }
    }

    void start()
    {
        ThreadPool pool = new ThreadPool( 10);

//          for (int i = 0; i < 25; i++)
//          {
//              pool.addTask( new RunnableTest(i));
//          }

          for (int i = 0; i < 15; i++)
          {
              pool.addTask( new ExceptionTest());
          }


         for (int i = 0; i < 5; i++)
         {
             pool.addTask( new RunnableTest(i));
         }


    }

    public static void main( String args[])
    {

        ThreadPoolTest test = new ThreadPoolTest();
        test.start();

    }


}
