
/********************************************************************************************
* CVS Info
*
* $Source: /cvsroot/jmailsrv/jmailserver/at/jps/threadpool/ThreadPoolThread.java,v $
*
* $Author: furykid $
* $Date: 2002/01/20 16:13:29 $
*
* modification history:
*
* $Log: ThreadPoolThread.java,v $
* Revision 1.2  2002/01/20 16:13:29  furykid
* added new header for cvs information
*

*********************************************************************************************/

package at.jps.threadpool;

/**
 * this class represents a workerthread which will be
 * processing queued tasks
 *
 * @author Johannes Plachy
 * @version 1.0
 */
class ThreadPoolThread extends Thread
{
    private ThreadPool threadPool;

    /**
     * constructs a workerthread
     *
     * @param pool   pool the workerthread belongs to and which coordinates
     *               the tasks to be worked on
     */
    ThreadPoolThread( ThreadGroup threadGroup,  ThreadPool threadPool)
    {
        super(threadGroup, (Runnable)null);

        this.threadPool = threadPool;
    }


    /**
     * we wait and execute tasks
     *
     * @see java.lang.Runnable#run()
     */
    public void run()
    {
        while (true)
        {
            // this operation will block until a task is present

            Runnable task = threadPool.getNextTask();

            try
            {
                task.run();
            }
            catch (Throwable x)
            {
                // we catch here for savety reasons
                // if we would not our thread would get killed
                // we could decide to rethrow the exception to
                // activate our unhandledExceptionHandler or simply
                // continue
            }
        }
    }
}
